<?php 

$expectedApiKey = '86becd3d6b404a52';

// Ensure the request is a POST request
if($_SERVER['REQUEST_METHOD'] === 'POST') {

    // Get the API key from the request header
    $apiKey = $_SERVER['HTTP_X_API_KEY'] ?? '';

    if ($apiKey === $expectedApiKey) {
        // API key is valid

        // Get the JSON data from the request body
        $jsonData = file_get_contents('php://input');
        
        // Check if the data is valid JSON
        $data = json_decode($jsonData, true);
        
        if($data === null) {
            // JSON data is invalid
            http_response_code(400); // Bad Request
            echo json_encode(['error' => 'Invalid JSON data']);

        } else {
            // JSON data is valid, and it's in the $data variable
            // You can now process the data as needed
            // For example, you can access specific fields using $data['key1'] and $data['key2']

            // check if the event post exists
            $existing_posts = get_posts(array(
                'post_type'         => 'event',
                'posts_per_page'    => -1,
                'meta_query'        => array(
                    array(
                        'key'       => 'eb_event_id',
                        'value'     =>  $data['eb_event_id'],
                    ),
                ),
            ));
            if($existing_posts && is_array($existing_posts)) {
                $post_id = $existing_posts[0]->ID;
            }

            $eventData = array(
                'post_title'    => $data['title'],
                'post_status'   => 'publish',
                'post_type'     => 'event',
                'post_name'     => $data['slug'],
            );
            $post_id = wp_insert_post($eventData);

            $acf_fields = $data['acf'];
            foreach($acf_fields as $key => $value) {
                if($key != 'event_series_dates' && $key != 'event_venue') {
                    update_field($key, $value, $post_id);
                }
                
            }


            // $remoteData = array(
            //     'title'             => $event['name']['text'],
            //     'status'            => 'publish',
            //     'slug'              => $event_slug,
            //     'acf'       => array(
            //         'event_object_type'     => 'eventbrite',
            //         'event_organiser'       => $organiser,
            //         'event_capacity'        => $event['capacity'],
            //         'event_status'          => $event['status'],
            //         'event_visibility'      => $event['listed'],
            //         'event_is_free'         => $event['is_free'],
            //         'eb_event_id'           => $event['id'],
            //         'event_summary'         => $event['description']['text'],
            //         'full_description'      => $full_description,
            //         'featured_image'        => $event['logo']['original']['url'],
            //         'online_event'          => $event['online_event'],
            //         'is_event_series'       => $event['is_series'],
            //         'event_updated_date'    => $updated,
            //         'event_series_dates'    => $series_dates_array,
            //         'event_venue'           => $venue_obj,
            //     ),
            // );

            
            // Respond with a success message
            echo json_encode(['message' => 'JSON data received and processed successfully']);
        }




    } else {
        // Invalid API key
        http_response_code(401); // Unauthorized
        echo json_encode(['error' => 'Unauthorized']);
    }
} else {
    // Not a POST request
    http_response_code(405); // Method Not Allowed
    echo json_encode(['error' => 'Only POST requests are allowed']);
}